      !***********************************************************************!
      SUBROUTINE  domaine(  nbdims,  dims,  coords  )
      !***********************************************************************!
!
      USE numerics
!
      IMPLICIT  NONE
!
      INCLUDE 'comthd.h'
!
INTERFACE
!
      INCLUDE 'i_equilibrage.h'
!
END INTERFACE
!
!--Declaration des arguments
!
! Nombre de directions spatiales
      INTEGER,                        INTENT(IN)   ::  nbdims
!
! Nombre de processus par direction spatiale
      INTEGER,  DIMENSION(1:nbdims),  INTENT(IN)   ::  dims
!
! Coordonnees du processus courant dans la topologie cartesienne
      INTEGER,  DIMENSION(1:nbdims),  INTENT(IN)   ::  coords
!
!--Declaration des variables locales
!
! 
      !***********************************************************************!
!
!Informations  sur  la  topologie
!Calcul  des  indices  des  points  suivant  x  dans  chaque  domaine
      CALL  equilibrage(  ntx,  dims(1),  coords(1),  sx,  ex  )
!
!Calcul  des  indices  des  points  suivant  y  dans  chaque  domaine
      CALL  equilibrage(  nty,  dims(2),  coords(2),  sy,  ey  )
!
!Calcul  des  indices  des  points  suivant  y  dans  chaque  domaine
      CALL  equilibrage(  ntz,  dims(3),  coords(3),  sz,  ez  )
!
!     sx = 1
!     ex = ntx
!
!     sy = 1
!     ey = nty
!
!     sz = 1
!     ez = ntz
!
!Informations sur le maillage
      hx  =  1.0_rp  /  real( ntx + 1, rp)
      hy  =  1.0_rp  /  real( nty + 1, rp)
      hz  =  1.0_rp  /  real( ntz + 1, rp)
!
      RETURN
      END  SUBROUTINE  domaine

